'From Squeak3.7gamma of ''17 July 2004'' [latest update: #5987] on 3 October 2006 at 9:57:05 pm'!

!SortedCollection methodsFor: 'binary search' stamp: 'BG 2/22/2002 12:20'!
fastIncludes: anObject
	"Answer whether anObject is one of the receiver's elements."

	^ (self fastIndexOf: anObject) ~= 0! !

!SortedCollection methodsFor: 'binary search' stamp: 'BG 2/22/2002 11:08'!
fastIndexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self fastIndexOf: anElement ifAbsent: [0]! !

!SortedCollection methodsFor: 'binary search' stamp: 'BG 2/22/2002 11:09'!
fastIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the 
	result of evaluating the argument, exceptionBlock."

	^ self fastIndexOf: anElement startingAt: 1 ifAbsent: exceptionBlock! !

!SortedCollection methodsFor: 'binary search' stamp: 'BG 2/22/2002 11:07'!
fastIndexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

  "  use binary search to find the index.  "

      | index low high item localSortBlock |

  low := firstIndex + start - 1.
  high := lastIndex.
  localSortBlock := sortBlock isNil
         ifTrue: [[:x :y | x <= y]]
         ifFalse: [sortBlock].
  [index := high + low // 2.
   low > high]
     whileFalse:
       [(item := array at: index) = anElement
           ifTrue: [ ^index - firstIndex + 1].
        (localSortBlock value: item
                   value: anElement)
            ifTrue:  [low := index + 1]
            ifFalse: [high := index - 1]].
 ^ exceptionBlock value! !

!SortedCollection methodsFor: 'binary search' stamp: 'BG 2/22/2002 10:59'!
fastRemove: oldObject ifAbsent: absentBlock

  "  use binary search to find the object to be removed.  "

      | index low high item localSortBlock |

  low := firstIndex.
  high := lastIndex.
  localSortBlock := sortBlock isNil
         ifTrue: [[:x :y | x <= y]]
         ifFalse: [sortBlock].
  [index := high + low // 2.
   low > high]
     whileFalse:
       [(item := array at: index) = oldObject
           ifTrue: [self removeIndex: index. ^item].
        (localSortBlock value: item
                   value: oldObject)
            ifTrue:  [low := index + 1]
            ifFalse: [high := index - 1]].
 ^ absentBlock value! !


!SortedCollection reorganize!
('accessing' at:put: median sortBlock sortBlock:)
('adding' add: addAll: addFirst: copyEmpty)
('comparing' =)
('copying' copy)
('enumerating' collect:)
('private' indexForInserting: insert:before: reSort should:precede: sort:to:)
('binary search' fastIncludes: fastIndexOf: fastIndexOf:ifAbsent: fastIndexOf:startingAt:ifAbsent: fastRemove:ifAbsent:)
('topological sort' sortTopologically)
!

